<?PHP  /*/mod/mlo/editorjnlp.php, (c)2008, Matthias Meisenberger, www.mobilemoodle.org */
	global $CFG, $USER;
/// This page prints a particular instance of mlo

    require_once('../../config.php');
    require_once('lib.php');

    $id = optional_param('id', PARAM_INT); // course module id
    $a = optional_param('m',PARAM_INT); // instance id
     if ($id) {
        if (! $cm = get_record('course_modules', 'id', $id)) {
            error('Course Module ID was incorrect');
        }

        if (! $course = get_record('course', 'id', $cm->course)) {
            error('Course is misconfigured');
        }

        if (! $mlo = get_record('mlo', 'id', $cm->instance)) {
            error('Course module is incorrect');
        }

    } else {
        if (! $mlo = get_record('mlo', 'id', $a)) {
            error('Course module is incorrect');
        }
        if (! $course = get_record('course', 'id', $mlo->course)) {
            error('Course is misconfigured');
        }
        if (! $cm = get_coursemodule_from_instance('mlo', $mlo->id, $course->id)) {
            error('Course Module ID was incorrect');
        }
    }

    // log in to course
    require_login($course->id);
    
    $strmlos = get_string('modulenameplural', 'mlo');
    $strmlo  = get_string('modulename', 'mlo');
    
    $context = get_context_instance(CONTEXT_COURSE, $course->id);

    // check if the current user is allowed to edit the MLO
    if(has_capability('moodle/course:manageactivities', $context))
    {

	    // log action
	    add_to_log($course->id, 'mlo', 'edit', "editorjnlp.php?id=$cm->id", "$mlo->id");


        // retrieve category list
        $category = '';
        if($course->category!=0){
            $cat = get_record('course_categories','id',$course->category);
            if($cat != false){ // if a category exists
                $category = $cat->name;
                // recursively check for parent categories
                while ($cat->parent != 0) {
                    $cat = get_record('course_categories','id',$cat->parent);
                    $category = $cat->name . '|' . $category;
                    }
                    // add final separator
                    $category .= '|';
                }
        }
        // at last add course short name
        $category .= $course->shortname;

        // get language
        $lang = substr(current_language(),0,2);

        // increase version
        $version = $mlo->version + 1;

        // generate unique hash
        $pass = md5($mlo->id . $CFG->mlo_pass);
        header('Content-type: application/x-java-jnlp-file');
		header('Content-Disposition: attachment; filename="mleeditor.jnlp"');
	
echo '<?xml version="1.0" encoding="utf-8"?>';
?>
<jnlp spec="1.0">
  <information>
    <title>MLE Editor</title>
    <vendor>eLibera OEG</vendor>
    <description kind='tootltip'>MLE-Editor</description>
    <description kind='one-line'>WYSIWYG-Editor for mobile contents</description>
  </information>
  <security>
      <all-permissions/>
  </security>
    <resources>
       <j2se version="1.4+" href="http://java.sun.com/products/autodl/j2se" />
      <jar href="<?=$CFG->mlo_jnlp_editor_url?>mleEditor.jar"/>
      <jar href="<?=$CFG->mlo_jnlp_editor_url?>mleEditor_app.jar"/>
      <jar href="<?=$CFG->mlo_jnlp_editor_url?>mleEditor_sound.jar"/>
    </resources>
  <application-desc main-class="com.elibera.ccs.app.MLEeditor"> 
<argument>contentid=<?=$mlo->id?></argument>
     <argument>user=<?=$USER->username?></argument>
     <argument>userid=<?=$USER->id?></argument>
     <argument>pass=<?=$pass?></argument>
     <argument>title=<?=$mlo->name?></argument>
     <argument>desc=<?=$mlo->description?></argument>
     <argument>lang=<?=$lang?></argument>
     <argument>editorlang=<?=$lang?></argument>
     <argument>version=<?=$version?></argument>
     <argument>content=false</argument>
     <argument>kName=<?=$category?></argument>
     <argument>saveurl=<?=$CFG->wwwroot . '/mod/mlo/editor/editor_set.php'?></argument>
     <argument>openurl=<?=$CFG->wwwroot . '/mod/mlo/editor/editor_get.php'?></argument>
     <argument>ttsurl=<?=$CFG->mlo_tts_url?></argument>
     <argument>metaMLEDetail=</argument>
     <argument>metaMLERefresh=</argument>
     <argument>metaMLEBewerten=</argument>
     <argument>metaMLEUser=contact.php&amp;id=</argument>
  </applet-desc>
</jnlp>
        <?php
    }
    else {
        print_header("$course->shortname: $mlo->name", "$course->fullname",
                 "$navigation <a href=index.php?id=$course->id>$strmlos</a> -> $mlo->name",
                  '', '', true, update_module_button($cm->id, $course->id, $strmlo),
                  navmenu($course, $cm));
 // log action
        add_to_log($course->id, 'mlo', 'edit', "editorjnlp.php?id=$cm->id", "$mlo->id");

        echo('<h2>' . $mlo->name . '</h2><br/>');
        echo('<h2>');
        echo(print_string('description','mlo'));
        echo('</h2><br />');
        echo('<p>' . $mlo->description . '</p>');
        echo('<h3>');
        echo(print_string('view_momo','mlo'));
        echo('</h3><br />');        
    }
?>
